# -*- coding: utf-8 -*-
# version: 0.0.5-kolli

"""This library is based on minions database, its just more adaptable"""

class database:
    
    structure = (
        ( 'id', str() ),
        ( 'value', str() )
        )

    dbfile = "db.conf"
    dbengine = ""
    idname = "id"

    nodeids = list()  # used to store nodes id's.
    nodes = list()  # used to store nodes.
    dberror = str() # used to store errors in...

    def __init__( self ):
        import ConfigParser
        self.dbengine = ConfigParser.ConfigParser()

    class DBNode:
        """used for constructing Nodes (in ram not on file/database)"""
        node_id = str() # first datatype
        values = list()
    
        def __init__( self, node_id, node_data, structure ):
            self.node_id = node_id
            self.values = node_data
            self.structure = structure

        def get( self, element ):
            """Returns a named element"""
            for x in range( 0, len( self.structure )):
                if element == self.structure[x][0]:
                    return self.values[x]
            return "error"

    # code...
    def init( self, dbfile, structure ):
        """should be the first call to the database library.
        Returns False if there was a error (see dberror for details).
        Otherwise it returns True. Also adds all id's to a tuple."""
        self.dbfile = dbfile
        self.structure = structure
        self.idname = self.structure[0][0]
        self.dbengine.read( self.dbfile )
        self.nodeids = self.dbengine.sections()
        return True

    # database routines
    def readNode( self, node_id ):
        """reads the node and stores it in the list nodes.
        Returns the array id on success else -1"""
        # check if its allready loaded
        for x in range( 0, len(self.nodes) ):
            if self.nodes[x].values[0] == node_id:
                return x
        # check if there is souch a id
        if not self.dbengine.has_section( node_id ):
            self.dberror = "no node with id %s" % node_id
            return -1
        # if no errors carry on
        values = list()
        for item in self.structure:
            if item[0] == self.idname:
                values.append( node_id )
            elif type( item[1] ) == str:
                # read as str
                values.append( self.dbengine.get( node_id, item[0] ))
            elif type( item[1] ) == int:
                values.append( self.dbengine.getint( node_id, item[0] ))
            else:
                self.dberror = "%s is not a known type..." % type( item[1] )
                return -1
        # package as a DBNode
        self.nodes.append( self.DBNode( node_id, values, self.structure ))
        return len( self.nodes ) -1 # well its a newly added id it must be the last ;)
        
    def writeNode( self, node_id, values ):
        """writes the node to file, values is a list of elements
        (remeber the ORDER, and that its the same as that for DBNode.values)."""
        if self.dbengine.has_section( node_id ):
            # if there is one delete it (ig: update it less nicely ;) )
            if not self.removeNode( node_id ):
                self.dberror = "unable to remove '%s' from db" % node_id
                return False
            # remove it from the cache
            for x in range( 0, len(self.nodes) ):
                if self.nodes[x].values[0] == node_id:
                    self.nodes.__delitem__(x)
        # write too the db
        self.dbengine.add_section( node_id )
        for x in range( 0, len(self.structure) ): # add the values
            if self.structure[x][0] == self.idname:
                pass
            else:
                try:
                    if type( self.structure[x][0] ) == str:
                        self.dbengine.set( node_id, self.structure[x][0], values[x] )
                    elif type( self.structure[x][0] ) == int:
                        self.dbengine.setint( node_id, self.structure[x][0], values[x] )
                except:
                    self.dberror = "faulty node values! (mismatch at %s)" % self.structure[x][0]
                    return False
        dbfp = open( self.dbfile, 'w' )
        self.dbengine.write( dbfp )
        dbfp.close()
        self.updateNodeList()
        return True
        
    def removeNode( self, node_id ):
        """Removes the node from the database"""
        if not self.dbengine.has_section( node_id ):
            self.dberror = "no node with id %s" % node_id
            return False
        for x in range( 0, len(self.nodes) ):
            if self.nodes[x].values[0] == node_id:
                    self.nodes.__delitem__(x)
        self.dbengine.remove_section( node_id )
        dbfp = open( self.dbfile, 'w' )
        self.dbengine.write( dbfp )
        dbfp.close()
        self.updateNodeList()
        return True

    def updateNodeList( self ):
        """updates the list of nodes (ig: rereading)"""
        self.dbengine.read( self.dbfile )
        self.nodeids = self.dbengine.sections()
