# -*- coding: utf-8 -*-
from random import randint
import time, re
import database
import db_structs
#import logger

# This is a modified knowledge, modified to match socktroll more

# globals
nick = str()
karma_fascist = True
karma_show = True
troll_client = None # a reference to current socktroll_client

# files
know = "db/knowledge.db"
seenf = "db/seen.db"
mesgf = "db/mesgf.db"

# databases
dbknow = database.database()
dbknow.init( know, db_structs.knowledge )

dbseen = database.database()
dbseen.init( seenf, db_structs.lastseen )

dbmsg = database.database()
dbmsg.init( mesgf, db_structs.messages )

# generator lists
list_ok = ( 'Okej', 'Ok', 'Hmm.. ok', 'Jaja..', 'klart...' )
list_no = ( 'Nej', 'Nejje', 'Nopp', 'Oh nej' )
list_err = ( 'Ajdå', 'Det gick inte...', 'Error', 'Nej' )

# debug
#if debugme == 2:
#    dbg_logg = logger.logger('DEBUG_logg.log')

def praseQ( msg, nick ):
    lmsg = msg
    msg = msg.split(' ')

    # test if its a question about a word
    hit = re.search( "^vad är (?:en|ett)? ?(.+)\??$", lmsg )
    if hit:
        return read_know( hit.group(1) )
    
    # test if its a definition
    hit = re.search( "^(?:en|ett)? ?(.+) är (.+)$", lmsg )
    if hit:
        return write_know( hit.group(1), hit.group(2) )
    
    # if someone wish to remove a definition
    hit = re.search( "^(?:glöm|ta|radera) (?:bort )?(.+)$", lmsg )
    if hit:
        return del_know( hit.group(1) )

    # seen (är inte pythons syntax för söt...)
    hit = re.search( "^när (?:såg|sågs) (?:du )? ?(?:till)? ?(\w+) ?(?:till)? ?senast ?(?:till)?\??$", lmsg )
    if not hit:
        hit = re.search( "^när (?:såg|sågs) (?:du )? ?senast ?(?:till)? (\w+)\??$", lmsg )
    if hit:
        return seen_last( hit.group(1) )

    return "!SILENT!"

# knowledge related

def mk_thing_def( listx ):
     string = ""
     for x in listx:
         if x != ',':
             string += " %s" % x
         else:
             string += ", "
     return string[1:]

def write_know( thing, thing_is ):
    # remove cruft
    thing_is = thing_is[:-1] + thing_is[-1].strip('?').strip('!').strip('.')
    thing_is = thing_is.lower()
    dbknow.updateNodeList()
    if not thing in dbknow.nodeids:
        values = [ thing, thing_is ]
        status = dbknow.writeNode( thing, values )
        if status == True:
            return gen_ok() + " ska minnas det."
        else:
            return gen_error() + " fel koden var: '%s'" % dbknow.dberror
    else:
        return gen_no() + " %s har redan en något."

def read_know( thing ):
    # remove cruft
    thing = thing.strip('?').strip('!').strip('.').lower()

    dbknow.updateNodeList()
    if thing in dbknow.nodeids:
        pos = dbknow.readNode( thing )
        return dbknow.nodes[pos].values[1]
    return gen_no() + " jag vet inte vad %s är." % thing

def del_know( thing ):
    thing = thing.strip('?').strip('!').strip('.').lower()
    
    dbknow.updateNodeList()
    if thing in dbknow.nodeids:
        status = dbknow.removeNode( thing )
        if status == True:
            return gen_ok() + " poff borta"
        else:
            return gen_err() + " den onda databasen sa: '%s'" % dbknow.dberror
    else:
        return gen_no() + " känner inte till det..."
    
# friend functions
def is_nick( thing ):
    """Check if a thing is a nick"""
    return thing in troll_client.users or thing in dbseen.nodeids

# seen/last stiffies
def seen_update( nick, action ):
    """please valid actions are: part, join, chan.
    chan should never ever log the message.
    chan are all in channel stuff like: msg, action, rename"""
    xtime = time.strftime( "%H:%M" )
    xdate = time.strftime( "%d/%m/%y" )
    values = [ nick, xtime, xdate, action ]
    status = dbseen.writeNode( nick, values )

def seen_last( nick ):
    nick = nick.strip('?').strip('!').strip('.').lower()
    
    dbseen.updateNodeList()

    if nick in dbseen.nodeids:
        pos = dbseen.readNode( nick )
        now_date = time.strftime( "%d/%m/%y" )
        
        xtime = dbseen.nodes[pos].get( "time" )
        xdate = dbseen.nodes[pos].get( "date" )
        action = dbseen.nodes[pos].get( "action" )
        
        tmp_str = str()
        if now_date != xdate:
            tmp_str = "såg %s senast %s %s" %( nick, xdate, xtime )
        else:
            tmp_str = "såg %s senast %s" %( nick, xtime )

        return tmp_str
    else:
        return gen_no() + " jag har inte något minne av att sett " + nick

# Messages relaterat
def msg_write( to_nick, from_nick, msg ):
    pass

def msg_get( nick ):
    """Returnerar alla medellanden till nick (på ett formaterat sätt), om han har några"""
    return "!SILENT!"

# text generation
def gen_ok():
    return list_ok[ randint( 1, len( list_ok )) -1 ]

def gen_no():
    return list_no[ randint( 1, len( list_no )) -1 ]

def gen_err():
    return list_err[ randint( 1, len( list_err )) -1 ]
